/**************************************************
 Classe Brique pour jeu de Casse-Briques
 
 J. Labbé - Lycée Boissy d'Anglas, Annonay (07)
 D'après le projet ISN 2015 de Jérémy, Jules et Nicolas
 **************************************************/

class Brique {
  // position et dimension de la brique
  int xposition;
  int yposition;
  int xtaille;
  int ytaille;
  // si etat==0 la brique est détruite
  int etat;

  /*
    Setters
    */
 void ChoisirPosition(int x, int y)  {xposition=x; yposition=y;}
 void ChoisirTaille(int x, int y)  {xtaille=x; ytaille=y;}
 void ChoisirEtat(int e)  {if (e<=6 && e>=0) etat=e;}

  /*
    Créateurs
   */
  Brique()
  {
    xposition=0; //centre de la brique
    yposition=0;

    xtaille=50;
    ytaille=30;

    etat=1;
  };

 int est_touchee(float xballe, float yballe, float rballe) {
    /*
      fonction est_touchee
     Renvoie :
     0 : brique détruite ou non touchée
     1 : brique touchée par en dessus ou en dessous
     2 : brique touchée latéralement
     */
    if (etat<=0) return 0;

    if ( (xballe+rballe > xposition && xballe-rballe < xposition+xtaille) 
      && (yballe+rballe > yposition && yballe-rballe < yposition+ytaille) )
    { // Brique touchée
      etat=etat-1;

      float minx = abs(xposition - xballe - rballe);
      if ( minx > abs(xposition + xtaille - xballe + rballe) ) minx = abs(xposition + xtaille - xballe + rballe);

      float miny = abs(yposition - yballe - rballe);
      if ( miny > abs(yposition + ytaille - yballe + rballe) ) miny = abs(yposition + ytaille - yballe + rballe);

      if ( minx < miny)
        return 2;
      else
        return 1;
    } else
      return 0;
  }


  void dessiner()
    /*
    dessiner la brique
     */
  {
    if (etat>0) {
      if      (etat==1) fill(#ff0000);
      else if (etat==2) fill(#00ff00);
      else if (etat==3) fill(#0000ff);
      else if (etat==4) fill(#ffcc33);
      else if (etat==5) fill(#33ffcc);
      else if (etat==6) fill(#cc33ff);
      else fill(#ffffff);
      stroke(50);
      rect(xposition, yposition, xtaille, ytaille);
    }   
  }
}
